VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2145
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2145
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2160
      Top             =   1320
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "..."
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   4080
      TabIndex        =   5
      Top             =   840
      Width           =   375
   End
   Begin VB.CommandButton cmdDeleteDSN 
      Caption         =   "Delete DSN"
      Height          =   495
      Left            =   3240
      TabIndex        =   4
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox txtPathToData 
      Height          =   285
      Left            =   360
      TabIndex        =   3
      Text            =   "Biblio.mdb"
      Top             =   840
      Width           =   3615
   End
   Begin VB.TextBox txtDsnName 
      Height          =   285
      Left            =   360
      TabIndex        =   2
      Text            =   "Test DSN"
      Top             =   480
      Width           =   4095
   End
   Begin VB.TextBox txtDriver 
      Height          =   285
      Left            =   360
      TabIndex        =   1
      Text            =   "Microsoft Access Driver (*.mdb)"
      Top             =   120
      Width           =   4095
   End
   Begin VB.CommandButton cmdAddDSN 
      Caption         =   "Create DSN"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   1440
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'This is tested under Win 95/98 & NOT UNDER WIN 2K / WIN NT SERVER/W-STATION
'so I cannot vouch for this code excuting properly under those operating
'systems.
'If you like the code give me mention
'If not at least tell me what you think about it
'
'Craig
'caf@ziplip.com

Private Declare Function SQLConfigDataSource Lib "odbccp32.dll" ( _
   ByVal hwndParent As Long, _
   ByVal fRequest As Integer, _
   ByVal lpszDriver As String, _
   ByVal lpszAttributes As String _
   ) As Long

Private Declare Function RegCloseKey Lib "advapi32" ( _
   ByVal hKey As Long _
   ) As Long

Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" ( _
   ByVal hKey As Long, _
   ByVal lpValueName As String, _
   ByVal lpReserved As Long, _
   ByRef lpType As Long, _
   ByVal lpData As String, _
   ByRef lpcbData As Long _
   ) As Long

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" ( _
   ByVal hKey As Long, _
   ByVal lpSubKey As String, _
   ByVal Reserved As Long, _
   ByVal samDesired As Long, _
   phkResult As Long _
   ) As Long

   Private Const REG_BINARY& = 3                 ' Free form binary
   Private Const REG_SZ& = 1                     ' Unicode null terminated string
   Private Const HKEY_CURRENT_USER& = &H80000001
   Private Const HKEY_LOCAL_MACHINE& = &H80000002
   Private Const KEY_ALL_ACCESS& = &H2003F

'The System DSN features are only available
'to systems running ODBC 2.5 & higher
Public Enum ACTION
   ODBC_ADD_DSN& = 1            ' Add User data source
   ODBC_CONFIGURE_DSN& = 2      ' Configure existing DSN
   ODBC_REMOVE_DSN& = 3         ' Delete data source
   ODBC_ADD_SYS_DSN& = 4        ' Add system data source
   ODBC_CONFIG_SYS_DSN& = 5     ' Modify an existing system data source
   ODBC_REMOVE_SYS_DSN = 6      ' Remove an existing system data source
   ODBC_REMOVE_DEFAULT_DSN& = 7 ' Remove the default data source
End Enum
Public Sub ConfigureSystemDSN(ByVal sDSN As String, _
   ByVal sDriver As String, _
   ByVal sDBFile As String, _
   ByVal eAction As ACTION _
   )

   Dim sAttributes   As String
   Dim sDBQ          As String
   Dim sRegValue     As String
   Dim lRetVal       As Long
   Dim hKey          As Long
   Dim lValueType    As Long
   Dim sMessage      As String

   If RegOpenKeyEx(HKEY_CURRENT_USER, _
      "Software\ODBC\ODBC.INI\" & sDSN, _
      0, _
      KEY_ALL_ACCESS, hKey _
      ) = 0 Then

      sRegValue = String(1024, 0)

      If RegQueryValueEx(hKey, _
         "DBQ", _
         0, _
         lValueType, _
         sRegValue, _
         Len(sRegValue) _
         ) = 0 Then

         If lValueType = REG_SZ Then
            sDBQ = Left(sRegValue, InStr(sRegValue, vbNullChar) - 1)
         End If
      End If

      RegCloseKey hKey
   End If

   If (sDBQ = "" And (eAction = ODBC_ADD_DSN Or eAction = ODBC_ADD_SYS_DSN)) _
   Or _
      (sDBQ <> "" And (eAction = ODBC_REMOVE_DSN Or eAction = ODBC_CONFIGURE_DSN)) Then

      If Len(Dir(sDBFile)) = 0 Then
         MsgBox "Database file doesn't exist!", vbOKOnly + vbCritical, "Cannot Continue"
      Else
         sAttributes = "DSN=" & sDSN & vbNullChar & "DBQ=" & sDBFile & vbNullChar
         lRetVal = SQLConfigDataSource(0&, eAction, sDriver, sAttributes)
         MsgBox "Done!"
      End If
   Else
      If eAction = ODBC_ADD_DSN Or _
         eAction = ODBC_ADD_SYS_DSN Then

         sMessage = " already exists!"
      Else
         sMessage = " doesn't exist!"
      End If

      MsgBox "DSN: " & txtDsnName.Text & sMessage
   End If

End Sub
Private Sub cmdAddDSN_Click()

   ConfigureSystemDSN txtDsnName.Text, txtDriver.Text, txtPathToData, ODBC_ADD_DSN

End Sub
Private Sub cmdBrowse_Click()

   With CommonDialog1
      .Filter = "*.*"
      .ShowOpen

      txtPathToData = .FileName
   End With

End Sub
Private Sub cmdDeleteDSN_Click()
   
   ConfigureSystemDSN txtDsnName.Text, txtDriver.Text, txtPathToData, ODBC_REMOVE_DSN

End Sub
